io.undertow.server.session

## Interface Session

    public interface Session

Represents a HTTP session.

Many operations provide both a blocking and an asynchronous version.

When using the async versions of operations no guarantee is made as to which threads will run listeners registered with this session manger. When using the blocking version the listeners are guaranteed to run in the calling thread.

Author:
  Stuart Douglas

### Method Summary

All Methods Instance Methods Abstract Methods
`String` `changeSessionId(HttpServerExchange exchange, SessionConfig config)` Generate a new session id for this session, and return the new id.
`Object` `getAttribute(String name)` Returns the object bound with the specified name in this session, or `null` if no object is bound under the name.
`Set<String>` `getAttributeNames()` Returns an `Set` of `String` objects containing the names of all the objects bound to this session.
`long` `getCreationTime()` Returns the time when this session was created, measured in milliseconds since midnight January 1, 1970 GMT.
`String` `getId()` Returns a string containing the unique identifier assigned to this session.
`long` `getLastAccessedTime()` Returns the last time the client sent a request associated with this session, as the number of milliseconds since midnight January 1, 1970 GMT, and marked by the time the container received the request.
`int` `getMaxInactiveInterval()` Returns the maximum time interval, in seconds, that the servlet container will keep this session open between client accesses.
`SessionManager` `getSessionManager()`
`void` `invalidate(HttpServerExchange exchange)` Invalidates this session then unbinds any objects bound to it.
`Object` `removeAttribute(String name)` Removes the object bound with the specified name from this session.
`void` `requestDone(HttpServerExchange serverExchange)` Called when a request is done with the session.
`Object` `setAttribute(String name, Object value)` Binds an object to this session, using the name specified.
`void` `setMaxInactiveInterval(int interval)` Specifies the time, in seconds, between client requests before the servlet container will invalidate this session.

### Method Detail

#### getId

    String getId()

Returns a string containing the unique identifier assigned to this session. The identifier is assigned by the servlet container and is implementation dependent.

Returns:
  a string specifying the identifier assigned to this session

#### requestDone

    void requestDone(HttpServerExchange serverExchange)

Called when a request is done with the session.

Parameters:
  `serverExchange` - The http server exchange for this request

#### getCreationTime

    long getCreationTime()

Returns the time when this session was created, measured in milliseconds since midnight January 1, 1970 GMT.

Returns:
  a `long` specifying when this session was created, expressed in milliseconds since 1/1/1970 GMT
Throws:
  `IllegalStateException` - if this method is called on an invalidated session

#### getLastAccessedTime

    long getLastAccessedTime()

Returns the last time the client sent a request associated with this session, as the number of milliseconds since midnight January 1, 1970 GMT, and marked by the time the container received the request.

Actions that your application takes, such as getting or setting a value associated with the session, do not affect the access time.

Returns:
  a `long` representing the last time the client sent a request associated with this session, expressed in milliseconds since 1/1/1970 GMT
Throws:
  `IllegalStateException` - if this method is called on an invalidated session

#### setMaxInactiveInterval

    void setMaxInactiveInterval(int interval)

Specifies the time, in seconds, between client requests before the servlet container will invalidate this session. A negative time indicates the session should never timeout.

Parameters:
  `interval` - An integer specifying the number of seconds

#### getMaxInactiveInterval

    int getMaxInactiveInterval()

Returns the maximum time interval, in seconds, that the servlet container will keep this session open between client accesses. After this interval, the servlet container will invalidate the session. The maximum time interval can be set with the `setMaxInactiveInterval` method. A negative time indicates the session should never timeout.

Returns:
  an integer specifying the number of seconds this session remains open between client requests
See Also:
  `setMaxInactiveInterval(int)`

#### getAttribute

    Object getAttribute(String name)

Returns the object bound with the specified name in this session, or `null` if no object is bound under the name.

Parameters:
  `name` - a string specifying the name of the object
Returns:
  the object with the specified name
Throws:
  `IllegalStateException` - if this method is called on an invalidated session

#### getAttributeNames

    Set<String> getAttributeNames()

Returns an `Set` of `String` objects containing the names of all the objects bound to this session.

Returns:
  an `Set` of `String` objects specifying the names of all the objects bound to this session
Throws:
  `IllegalStateException` - if this method is called on an invalidated session

#### setAttribute

    Object setAttribute(String name,
                        Object value)

Binds an object to this session, using the name specified. If an object of the same name is already bound to the session, the object is replaced.

If the value passed in is null, this has the same effect as calling `removeAttribute()`.

Parameters:
  `name` - the name to which the object is bound; cannot be null
  `value` - the object to be bound
Returns:
  An IOFuture containing the previous value
Throws:
  `IllegalStateException` - if this method is called on an invalidated session

#### removeAttribute

    Object removeAttribute(String name)

Removes the object bound with the specified name from this session. If the session does not have an object bound with the specified name, this method does nothing.

Parameters:
  `name` - the name of the object to remove from this session
Throws:
  `IllegalStateException` - if this method is called on an invalidated session

#### invalidate

    void invalidate(HttpServerExchange exchange)

Invalidates this session then unbinds any objects bound to it.

Throws:
  `IllegalStateException` - if this method is called on an already invalidated session

#### getSessionManager

    SessionManager getSessionManager()

Returns:
  The session manager that is associated with this session

#### changeSessionId

    String changeSessionId(HttpServerExchange exchange,
                           SessionConfig config)

Generate a new session id for this session, and return the new id.

Returns:
  The new session ID